"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseField = exports.encode = exports["default"] = exports.decode = void 0;

var _typeof2 = _interopRequireDefault(require("reshow-runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _slicedToArray2 = _interopRequireDefault(require("reshow-runtime/helpers/slicedToArray"));

var _getObjectValue = require("get-object-value");

var _reshowConstant = require("reshow-constant");

var toInt = function toInt(d) {
  return parseInt(d, 10);
};

var parseField = function parseField(s) {
  var iStar = s.indexOf(",");
  var len = toInt(s.substring(0, iStar));
  var val = s.substring(iStar + 1);
  return [len, val];
};

exports.parseField = parseField;

var encode = function encode(s) {
  var _v = JSON.stringify((0, _getObjectValue.toJS)(s));

  var vLen = _v.length;
  var result = vLen + "," + _v;
  return result;
};

exports.encode = encode;

var decode = function decode(s) {
  var _parseField = parseField(s),
      _parseField2 = (0, _slicedToArray2["default"])(_parseField, 2),
      vLen = _parseField2[0],
      value = _parseField2[1];

  return vLen === value.length ? JSON.parse(value) : null;
};

exports.decode = decode;

var Storage = /*#__PURE__*/function () {
  function Storage(_storage) {
    (0, _classCallCheck2["default"])(this, Storage);
    this._storage = _storage;
  }

  (0, _createClass2["default"])(Storage, [{
    key: "set",
    value: function set(k, v) {
      var s = encode(v);

      this._storage(k)(s);

      return new Storage(this._storage);
    }
  }, {
    key: "merge",
    value: function merge(arr) {
      var _this = this;

      if (!arr || _reshowConstant.OBJECT !== (0, _typeof2["default"])(arr)) {
        return this;
      }

      var pKeys = (0, _reshowConstant.KEYS)(arr);

      if (!pKeys || !pKeys.length) {
        return this;
      }

      pKeys.forEach(function (key) {
        return _this.set(key, arr[key]);
      });
      return new Storage(this._storage);
    }
  }, {
    key: "get",
    value: function get(k) {
      var s = this._storage(k)();

      if (!s) {
        return;
      }

      return decode(s);
    }
  }]);
  return Storage;
}();

var _default = Storage;
exports["default"] = _default;