"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

var _slicedToArray2 = _interopRequireDefault(require("reshow-runtime/helpers/slicedToArray"));

var _typeof2 = _interopRequireDefault(require("reshow-runtime/helpers/typeof"));

var _chai = require("chai");

var _Storage = _interopRequireWildcard(require("../Storage"));

var _reshowConstant = require("reshow-constant");

var fakeSetter = function fakeSetter(store) {
  return function (key) {
    return function (value) {
      if (_reshowConstant.UNDEFINED === (0, _typeof2["default"])(value)) {
        return store[key];
      } else {
        if (null == value) {
          return delete store[key];
        } else {
          store[key] = value;
        }
      }
    };
  };
};

describe("Storage", function () {
  it("Storage / parseField", function () {
    var s = "10,abcdefghij";

    var _parseField = (0, _Storage.parseField)(s),
        _parseField2 = (0, _slicedToArray2["default"])(_parseField, 2),
        len = _parseField2[0],
        val = _parseField2[1];

    (0, _chai.expect)(len).to.equal(10);
    (0, _chai.expect)(val).to.equal("abcdefghij");
  });
  it("Storage / encode, decode", function () {
    var o = {
      foo: "bar"
    };
    var sEncode = (0, _Storage.encode)(o);
    (0, _chai.expect)(sEncode).to.equal('13,{"foo":"bar"}');
    (0, _chai.expect)((0, _Storage.decode)(sEncode)).to.deep.equal(o);
  });
  it("test storage", function () {
    var fakeStore = {};
    var fakeStorage = new _Storage["default"](fakeSetter(fakeStore));
    var foo = fakeStorage.get('foo');
    (0, _chai.expect)(foo).to.be.undefined;
    foo = fakeStorage.set('foo', 'bar');
    (0, _chai.expect)(fakeStore).to.deep.equal({
      foo: '5,"bar"'
    });
    (0, _chai.expect)(foo.get('foo')).to.equal("bar");
  });
});