"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Storage", {
  enumerable: true,
  get: function get() {
    return _Storage["default"];
  }
});
exports.sessionStorage = exports.localStorage = void 0;

var _typeof2 = _interopRequireDefault(require("reshow-runtime/helpers/typeof"));

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _winDoc = require("win-doc");

var _reshowConstant = require("reshow-constant");

var _Storage = _interopRequireDefault(require("./Storage"));

var notSupport = {};

var getStorage = function getStorage(storageType) {
  return function (key) {
    return function (value) {
      var oWin = (0, _winDoc.win)();

      if (!oWin || notSupport[storageType]) {
        return;
      }

      var store = (0, _getObjectValue["default"])(oWin, [storageType]);

      if (_reshowConstant.UNDEFINED === (0, _typeof2["default"])(store)) {
        console.warn("Not support. [" + storageType + "]");
        notSupport[storageType] = true;
        return;
      }

      if (_reshowConstant.UNDEFINED === (0, _typeof2["default"])(value)) {
        return store.getItem(key);
      } else {
        try {
          if (null == value) {
            return store.removeItem(key);
          }

          return store.setItem(key, value);
        } catch (err) {
          store.clear();
          return store.setItem(key, value);
        }
      }
    };
  };
};

var localStorage = getStorage("localStorage");
exports.localStorage = localStorage;
var sessionStorage = getStorage("sessionStorage");
exports.sessionStorage = sessionStorage;