import _typeof from "reshow-runtime/es/helpers/typeof";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _slicedToArray from "reshow-runtime/es/helpers/slicedToArray";
import { toJS } from "get-object-value";
import { OBJECT, KEYS } from "reshow-constant";

var toInt = function toInt(d) {
  return parseInt(d, 10);
};

var parseField = function parseField(s) {
  var iStar = s.indexOf(",");
  var len = toInt(s.substring(0, iStar));
  var val = s.substring(iStar + 1);
  return [len, val];
};

var encode = function encode(s) {
  var _v = JSON.stringify(toJS(s));

  var vLen = _v.length;
  var result = vLen + "," + _v;
  return result;
};

var decode = function decode(s) {
  var _parseField = parseField(s),
      _parseField2 = _slicedToArray(_parseField, 2),
      vLen = _parseField2[0],
      value = _parseField2[1];

  return vLen === value.length ? JSON.parse(value) : null;
};

var Storage = /*#__PURE__*/function () {
  function Storage(_storage) {
    _classCallCheck(this, Storage);

    this._storage = _storage;
  }

  _createClass(Storage, [{
    key: "set",
    value: function set(k, v) {
      var s = encode(v);

      this._storage(k)(s);

      return new Storage(this._storage);
    }
  }, {
    key: "merge",
    value: function merge(arr) {
      var _this = this;

      if (!arr || OBJECT !== _typeof(arr)) {
        return this;
      }

      var pKeys = KEYS(arr);

      if (!pKeys || !pKeys.length) {
        return this;
      }

      pKeys.forEach(function (key) {
        return _this.set(key, arr[key]);
      });
      return new Storage(this._storage);
    }
  }, {
    key: "get",
    value: function get(k) {
      var s = this._storage(k)();

      if (!s) {
        return;
      }

      return decode(s);
    }
  }]);

  return Storage;
}();

export default Storage;
export { parseField, encode, decode };