import _slicedToArray from "reshow-runtime/es/helpers/slicedToArray";
import _typeof from "reshow-runtime/es/helpers/typeof";
import { expect } from "chai";
import Storage, { parseField, encode, decode } from "../Storage";
import { UNDEFINED } from "reshow-constant";

var fakeSetter = function fakeSetter(store) {
  return function (key) {
    return function (value) {
      if (UNDEFINED === _typeof(value)) {
        return store[key];
      } else {
        if (null == value) {
          return delete store[key];
        } else {
          store[key] = value;
        }
      }
    };
  };
};

describe("Storage", function () {
  it("Storage / parseField", function () {
    var s = "10,abcdefghij";

    var _parseField = parseField(s),
        _parseField2 = _slicedToArray(_parseField, 2),
        len = _parseField2[0],
        val = _parseField2[1];

    expect(len).to.equal(10);
    expect(val).to.equal("abcdefghij");
  });
  it("Storage / encode, decode", function () {
    var o = {
      foo: "bar"
    };
    var sEncode = encode(o);
    expect(sEncode).to.equal('13,{"foo":"bar"}');
    expect(decode(sEncode)).to.deep.equal(o);
  });
  it("test storage", function () {
    var fakeStore = {};
    var fakeStorage = new Storage(fakeSetter(fakeStore));
    var foo = fakeStorage.get('foo');
    expect(foo).to.be.undefined;
    foo = fakeStorage.set('foo', 'bar');
    expect(fakeStore).to.deep.equal({
      foo: '5,"bar"'
    });
    expect(foo.get('foo')).to.equal("bar");
  });
});